#ifndef Resolution
#define Resolution
#include "formule.hpp"

// Cherche un littéral dans c1 dont la négation est dans c2.
// Renvoie true si un tel littéral est trouvé.
bool pivot(cls_t c1, cls_t c2, lit_t & l_pivot);

// Calcule la résolvante de deux clauses
// le littéral passé en argument apparait dans c1 et sa négation est dans c2.
cls_t resolvante(cls_t c1, cls_t c2, lit_t l_pivot);

// Vrai si la clause contient un littéral et sa négation
bool tautologie(cls_t c);

// Vrai si une clause est dans une CNF.
// Cette version pourra être modifiée pour renvoyer vrai
// si la clause est impliquée par la CNF.
bool directement_impliquee_par(cls_t c, cnf_t f);

// Renvoie vrai si la CNF passée en argument est instatisfiable.
bool unsat(cnf_t f);

#endif
